<?php
// auth_hatena.php - Authentication function with Hatena API for PukiWiki
// Copyright (C) 2006 MATSUOKA Kohei
// License: GPL v2 or (at your option) any later version

// HatenaAPI authentication
function hatena_auth($page, $auth_flag, $exit_flag, $auth_pages, $title_cannot)
{
	// åؿư
	if (!isset($_SESSION)) {
		session_start();
	}
	// å̤ΩǤǧ
	if (!isset($_SESSION['user_id'])) {
		$user_id = hatena_authn($page, $auth_flag, $exit_flag, $title_cannot);
		if (!$user_id) {
			return FALSE;
		}
		// åCookie򿷵ȯ
		session_regenerate_id();
		$_SESSION['user_id'] = $user_id;
	}
	// ڡؤΥ¤å
	return hatena_authz($page, $auth_pages, $_SESSION['user_id']);
}

// ǧڽ
function hatena_authn($page, $auth_flag, $exit_flag, $title_cannot)
{
	global $hatena_api_key;
	global $hatena_secret;

	$api = new Hatena_API_Auth($hatena_api_key, $hatena_secret);
	// åȤ̵
	if (!$_GET['cert']) {
		// ǧڥե饰OFFʤǧڤʤ (PukiWiki)
		if (!$auth_flag || !$exit_flag) {
			return FALSE;
		}
		// ̤ɽƽλ
		hatena_login_html($page, $title_cannot, $api->uri_to_login($_GET));
		exit;
	}
	// cert ֤ϤƤIDפ
	$user_id = $api->login($_GET['cert']);
	return $user_id;
}

// ǧ
function hatena_authz($page, $auth_pages, $user_id)
{
	$user_list = authz_user_list($page, $auth_pages);
	if (empty($user_list) || in_array($user_id, $user_list)) {
		return TRUE;
	} else {
		return FALSE;
	}
}

// ڡ̾ȥꥹȤ龵ǧ桼ΰ
function authz_user_list($page, $auth_pages)
{
	global $auth_method_type;

	// Checked by:
	$target_str = '';
	if ($auth_method_type == 'pagename') {
		$target_str = $page; // Page name
	} else if ($auth_method_type == 'contents') {
		$target_str = join('', get_source($page)); // Its contents
	}

	$user_list = array();
	foreach($auth_pages as $page => $users) {
		if (preg_match($page, $target_str)) {
			foreach(explode(',', $users) as $user) {
				$user = trim($user);
				// g:롼̾פξϥ롼פȤߤʤ
				if (preg_match("/^g:(.*)$/", $user, $matchs)) {
					$group = $matchs[1];
					$user_list = array_merge($user_list, hatena_group_users($group));
				} else {
					array_push($user_list, $user);
				}
			}
		}
	}
	return $user_list;
}

// ϤƤʥ롼̾桼
function hatena_group_users($group)
{
	$uri = 'http://' . $group . '.g.hatena.ne.jp/diarylist?mode=rss';
  if (0) {
    $handle = fopen($uri, 'rb');
    // TODO: using cache?
    if(!$handle) {
      return false;
    }
    $contents = '';
    while (!feof($handle)) { $contents .= fread($handle, 8192); }
    fclose($handle);
  } else {
    $contents = hatena_group_users_stab();
  }
	$regex = '@<rdf:li rdf:resource="http://' . $group . '.g.hatena.ne.jp/([^/]+)/" />@';
	preg_match_all($regex, $contents, $matchs);
	return $matchs[1];
}

// ̤ɽ
function hatena_login_html($page, $title_cannot, $uri)
{
	// $body = $title = str_replace('$1',
	$title = str_replace('$1',
		htmlspecialchars(strip_bracket($page)), $title_cannot);
	$auth_url = htmlspecialchars($uri);
	$body = '<p>ڡԽˤϥɬפǤ</p>';
	$body .= '<p><a href="' . $auth_url . '">ϤƤǧAPIǥ󤹤</a></p>';
	$page = str_replace('$1', make_search($page), $title_cannot);
	catbody($title, $page, $body);
}
